//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2021 - Stephane MOTTELET
//
// This file is hereby licensed under the terms of the GNU GPL v3.0,
// For more information, see the COPYING file which you should have received
//
//--------------------------------------------------------------------------

#ifndef _IDABRIDGE_HXX_
#define _IDABRIDGE_HXX_

int IDARes(realtype t, N_Vector y, N_Vector ydot, N_Vector res, void *pManager);
int IDAJac(long int N, realtype t, realtype c, N_Vector y, N_Vector yp, N_Vector r, DlsMat J, void *user_data, N_Vector tmp1, N_Vector tmp2, N_Vector tmp3);
void IDAErrHandler(int error_code, const char *module, const char *function, char *msg, void *pManager);

typedef void (*IDADynRes)(int *n, double *t, double *y, double *ydot, double *res);
typedef void (*IDADynResWithPar)(int *n, double *t, double *y, double *ydot, double *res, double *pdblPar);

typedef void (*IDADynJac)(int *n, double *t, double *c, double *y, double *ydot, double *res, double *J);
typedef void (*IDADynJacWithPar)(int *n, double *t, double *c, double *y, double *ydot, double *res, double *J, double *pdblPar);

#endif
